- AnsibleFest
- Products
- Community
- Webinars & Training
- Blog

Documentation

# nxos_smu – Perform SMUs on Cisco NX-OS devices

- Synopsis
- Parameters
- Notes
- Examples
- Return Values
- Status

## Synopsis

- Perform software maintenance upgrades (SMUs) on Cisco NX-OS devices.

## Parameters

Parameter | Choices/Defaults | Comments
--- | --- | ---
file_system - |  | The remote file system of the device. If omitted, devices that support a file_system parameter will use their default values.
pkg - / required |  | Name of the remote package.
provider dictionary |  | Deprecated Starting with Ansible 2.5 we recommend using `connection: network_cli`. This option is only required if you are using NX-API. For more information please see the NXOS Platform Options guide. A dict object containing connection details.
| auth_pass string added in 2.5.3 |  | Specifies the password to use if required to enter privileged mode on the remote device. If authorize is false, then this argument does nothing. If the value is not specified in the task, the value of environment variable `ANSIBLE_NET_AUTH_PASS` will be used instead.
| authorize boolean added in 2.5.3 | Choices: no ← yes | Instructs the module to enter privileged mode on the remote device before sending any commands. If not specified, the device will attempt to execute all commands in non-privileged mode. If the value is not specified in the task, the value of environment variable `ANSIBLE_NET_AUTHORIZE` will be used instead.
| host string / required |  | Specifies the DNS host name or address for connecting to the remote device over the specified transport. The value of host is used as the destination address for the transport.
| password string |  | Specifies the password to use to authenticate the connection to the remote device. This is a common argument used for either cli or nxapi transports. If the value is not specified in the task, the value of environment variable `ANSIBLE_NET_PASSWORD` will be used instead.
| port integer | Default: "0 (use common port)" | Specifies the port to use when building the connection to the remote device. This value applies to either cli or nxapi. The port value will default to the appropriate transport common port if none is provided in the task. (cli=22, http=80, https=443).
| ssh_keyfile string |  | Specifies the SSH key to use to authenticate the connection to the remote device. This argument is only used for the cli transport. If the value is not specified in the task, the value of environment variable `ANSIBLE_NET_SSH_KEYFILE` will be used instead.
| timeout integer | Default: 10 | Specifies the timeout in seconds for communicating with the network device for either connecting or sending commands. If the timeout is exceeded before the operation is completed, the module will error. NX-API can be slow to return on long-running commands (sh mac, sh bgp, etc).
| transport string / required | Choices: cli ← nxapi | Configures the transport connection to use when connecting to the remote device. The transport argument supports connectivity to the device over cli (ssh) or nxapi.
| use_proxy boolean added in 2.5 | Choices: no yes ← | If `no`, the environment variables `http_proxy` and `https_proxy` will be ignored.
| use_ssl boolean | Choices: no ← yes | Configures the transport to use SSL if set to `yes` only when the `transport=nxapi`, otherwise this value is ignored.
| username string |  | Configures the username to use to authenticate the connection to the remote device. This value is used to authenticate either the CLI login or the nxapi authentication depending on which transport is used. If the value is not specified in the task, the value of environment variable `ANSIBLE_NET_USERNAME` will be used instead.
| validate_certs boolean | Choices: no yes ← | If `no`, SSL certificates will not be validated. This should only be used on personally controlled sites using self-signed certificates. If the transport argument is not nxapi, this value is ignored.

## Notes

Note

- Tested against NXOSv 7.3.(0)D1(1) on VIRL
- The module can only activate and commit a package, not remove or deactivate it.
- Use `transport=nxapi` to avoid connection timeout
- For information on using CLI and NX-API see the NXOS Platform Options guide
- For more information on using Ansible to manage network devices see the Ansible Network Guide
- For more information on using Ansible to manage Cisco devices see the Cisco integration page.

## Examples

    - nxos_smu:
        pkg: "nxos.CSCuz65185-n9k_EOR-1.0.0-7.0.3.I2.2d.lib32_n9000.rpm"

## Return Values

Common return values are documented here, the following are the fields unique to this module:

Key | Returned | Description
--- | --- | ---
commands list | always | commands sent to the device Sample: ['install add bootflash:nxos.CSCuz65185-n9k_EOR-1.0.0-7.0.3.I2.2d.lib32_n9000.rpm', 'install activate bootflash:nxos.CSCuz65185-n9k_EOR-1.0.0-7.0.3.I2.2d.lib32_n9000.rpm force', 'install commit bootflash:nxos.CSCuz65185-n9k_EOR-1.0.0-7.0.3.I2.2d.lib32_n9000.rpm']

## Status

- This module is not guaranteed to have a backwards compatible interface. [preview]
- This module is maintained by the Ansible Network Team. [network]

### Red Hat Support

More information about Red Hat’s support of this module is available from this Red Hat Knowledge Base article.

### Authors

- Gabriele Gerbino (@GGabriele)

Hint

If you notice any issues in this documentation, you can edit this document to improve it.